!
!    Copyright 2007-2020 Guy Munhoven
!
!    This file is part of Medusa.
!
!    Medusa is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Affero General Public License as
!    published by the Free Software Foundation, either version 3 of
!    the License, or (at your option) any later version.
!
!    Medusa is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!    See the GNU Affero General Public License for more details.
!
!    You should have received a copy of the Affero GNU General Public
!    License along with Medusa.  If not, see <https://www.gnu.org/licenses/>.
!


!-----------------------------------------------------------------------
      MODULE MOD_SEAFLOOR_WDATA
!-----------------------------------------------------------------------

      IMPLICIT NONE

      PRIVATE

      PUBLIC :: WDATA_CONTAINER

                                    ! Define below the contents of
                                    ! of the data container.
      TYPE WDATA_CONTAINER
                                    
        ! Fundamentally required data -- please do not change anything
        !                             between the next ...
        ! ==============================================================
        DOUBLE PRECISION :: wdbsl   ! * depth below sea-level
        DOUBLE PRECISION :: wtmpc   ! * temperature
        DOUBLE PRECISION :: wsalin  ! * salinity
        ! ==============================================================
        !                             ... and the previous line.


        ! Extra components can be added below the next line
        ! ==============================================================
        DOUBLE PRECISION :: womega_calc ! * Omega_Calc
        DOUBLE PRECISION :: wph         ! * pH
        ! ==============================================================

      END TYPE

!-----------------------------------------------------------------------
      END MODULE MOD_SEAFLOOR_WDATA
!-----------------------------------------------------------------------
