!
!    Copyright 2007-2020 Guy Munhoven
!
!    This file is part of Medusa.
!
!    Medusa is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Affero General Public License as
!    published by the Free Software Foundation, either version 3 of
!    the License, or (at your option) any later version.
!
!    Medusa is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!    See the GNU Affero General Public License for more details.
!
!    You should have received a copy of the Affero GNU General Public
!    License along with Medusa.  If not, see <https://www.gnu.org/licenses/>.
!


      MODULE MOD_MBM_EQNOCE_TXT
      
      USE MOD_MBM_GEOMETRY,
     >  ONLY: i_geohor_slv, i_geohor_dps, i_geolev_top, i_geolev_bot

      IMPLICIT NONE
      

! OrgM fluxes at given horizons
      CHARACTER(LEN=75), DIMENSION(i_geohor_slv+1:i_geohor_dps)
     >                   :: txt_orgm_flx

! OrgM deposition rates on sediment at different levels
      CHARACTER(LEN=75), DIMENSION(i_geolev_top+1:i_geolev_bot)
     >                   :: txt_orgm_sed

! OrgM remineralisation rates within given levels
      CHARACTER(LEN=75), DIMENSION(i_geolev_top+1:i_geolev_bot)
     >                   :: txt_orgm_rmn


! Format strings
      CHARACTER(LEN=19), PARAMETER
     >                   :: format7 = '(A25,5F8.2,2X,F8.2)'


      END MODULE MOD_MBM_EQNOCE_TXT
