!
!    Copyright 2007-2020 Guy Munhoven
!
!    This file is part of Medusa.
!
!    Medusa is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Affero General Public License as
!    published by the Free Software Foundation, either version 3 of
!    the License, or (at your option) any later version.
!
!    Medusa is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!    See the GNU Affero General Public License for more details.
!
!    You should have received a copy of the Affero GNU General Public
!    License along with Medusa.  If not, see <https://www.gnu.org/licenses/>.
!


MODULE MOD_MBM_WFLUXES

USE MOD_MBM_GEOMETRY, ONLY: ro1, nro1, ro3, nro3

IMPLICIT NONE

DOUBLE PRECISION, DIMENSION(ro1+1:ro3+nro3, ro1+1:ro3+nro3), SAVE ::  wflux
DOUBLE PRECISION, DIMENSION(ro1+1:ro3+nro3), SAVE                 :: wfluxi, wfluxo

! Water flux distribution data.
! Actual distribution calculated from these data by
! *setwfl*, called from *setgeo* (first time from *initia*)
DOUBLE PRECISION, DIMENSION(ro1+1:ro3+nro3, ro1+1:ro3+nro3), SAVE :: wflxvn, wflxvm, &
                                                                     wflxhn, wflxhm
DOUBLE PRECISION, SAVE                                            :: cofvn,  cofvm,  &
                                                                     cofhn,  cofhm

END MODULE MOD_MBM_WFLUXES
