      MODULE mod_medinterfaces

      IMPLICIT NONE

      INTERFACE
        SUBROUTINE GRIDEF(xzdn, vxzdn)
          USE mod_gridparam, ONLY: idnt, idnb, idit, idib
          DOUBLE PRECISION, DIMENSION(idnt:idnb) :: xzdn
          DOUBLE PRECISION, DIMENSION(idit:idib) :: vxzdn
          INTENT(OUT) :: xzdn, vxzdn
          OPTIONAL :: vxzdn
        END SUBROUTINE
      END INTERFACE


      INTERFACE
        SUBROUTINE REACRATE(azdn, aphi, ac, area, aproc)
        USE mod_indexparam, ONLY: ncompo
        USE mod_processdata, ONLY: nproc

        IMPLICIT NONE

        DOUBLE PRECISION                               :: azdn
        DOUBLE PRECISION                               :: aphi
        DOUBLE PRECISION, DIMENSION(ncompo)            :: ac
        DOUBLE PRECISION, DIMENSION(ncompo)            :: area
        DOUBLE PRECISION, DIMENSION(ncompo,nproc)      :: aproc

        INTENT(IN)  :: azdn, ac
        INTENT(OUT) :: area, aproc
        OPTIONAL    :: aproc
        END SUBROUTINE REACRATE
      END INTERFACE


      INTERFACE
        SUBROUTINE STORE_NC_AUX(filename, title_string)
          CHARACTER(len=256) :: filename, title_string
          INTENT(IN) :: filename, title_string
          OPTIONAL :: title_string
        END SUBROUTINE
      END INTERFACE


      END MODULE mod_medinterfaces
