!
!    Copyright 2007-2020 Guy Munhoven
!
!    This file is part of Medusa.
!
!    Medusa is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Affero General Public License as
!    published by the Free Software Foundation, either version 3 of
!    the License, or (at your option) any later version.
!
!    Medusa is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!    See the GNU Affero General Public License for more details.
!
!    You should have received a copy of the Affero GNU General Public
!    License along with Medusa.  If not, see <https://www.gnu.org/licenses/>.
!


!-----------------------------------------------------------------------
      SUBROUTINE COLUMN_N2XY(i_column, iflag, x, y)
!-----------------------------------------------------------------------

      ! Uses the following variables from MOD_SEAFLOOR_CENTRAL
      !  n_grid_seafloor (read only)
      !  x_seafloor (read only)
      !  y_seafloor (read only)


      IMPLICIT NONE

      INTEGER,          INTENT(IN)  :: i_column
      INTEGER,          INTENT(OUT) :: iflag
      DOUBLE PRECISION, INTENT(OUT) :: x, y


      IF ((i_column >= 1) .AND. (i_column <= n_grid_seafloor)) THEN

        x = x_seafloor(i_column)
        y = y_seafloor(i_column)

        iflag = 0

      ELSE

        iflag = 1 ! illegal i_column value

      ENDIF


      RETURN


!-----------------------------------------------------------------------
      END SUBROUTINE COLUMN_N2XY
!-----------------------------------------------------------------------
